﻿var TEST_TEXT;

//TEST_TEXT = 'запятая';

// ==========================================================
// ==========================================================

var OPTS = {
	/*'текст': {
		code: "",
		file: "<path>",
		arguments: []
    },*/
	'запятая': {
		code: "app.selection[0].insertionPoints[0].contents = ','"
	},
	'тире': {
		code: "app.selection[0].insertionPoints[0].contents = String.fromCharCode(0xA0)+'–'"
	},
	'печать': {
		file: "D:/Dropbox/Scripts Panel/1 PROJECTS/quickRangePrint/quickRangePrint 4.2.jsx"
	},

};

res = do_capture();
console(res.toSource());
if (res && res.transcript ) {
	console(res.transcript);
	if( OPTS[res.transcript] ){
		app.doScript(
			OPTS[res.transcript].code || new File(OPTS[res.transcript].file),
			1246973031,
			OPTS[res.transcript].arguments || []
		);
	}
	else alert( res.transcript );
}

// ==========================================================
// ==========================================================

function do_capture() { // return {transcript: '', error;''}
	console( 'do_capture()' );
	var port_out = 8082;
	var port_in = 8083;
	
	var address = 'localhost';
	var path = 'do_capture?response_port=' + port_in + (TEST_TEXT ? '&test_text=' + encodeURI(TEST_TEXT) : '');

	var socket_out = new Socket();
	socket_out.timeout = 1; // Тайм-аут в секундах, применяемый к операциям чтения или записи. (default: 10). Минимальное значение - 1.
	if (!socket_out.open(address + ':' + port_out)) {
		alert("Error of connecting with " + address);
		return;
	}

	/*var request = 
		"GET /" + path + " HTTP/1.1\n" +
		"Host: " + address + "\n" +
		"User-Agent: "+app.name.replace('Adobe ','')+")\n" +
		"Accept: text/plain\n" + 
		"Accept-Encoding:\n" +
		"Connection: keep-alive\n" +
		"Accept-Language: *\n" + 
		"Accept-Charset: utf-8\n\n";*/
	var request = "GET /" + path + " HTTP/1.0\n\n";
	socket_out.write(request);
	socket_out.close();
	console('socket_out.close()');


	var text_in;
	var socket_in = new Socket();

	if (socket_in.listen(port_in)) {
		console("Server listening on port " + port_in);
		var connection;
		var count = 0;
		while (count < 100) { // лимит ожидания - 10 сек.
			count++;
			console(count);
			connection = socket_in.poll();
			if (connection !== null) {
				console("client connected" + (connection.host.toString() ? " from " + connection.host.toString() : "") + ".");
				connection.timeout = 1000;

				while (true) {
					if (connection.connected) {
						text_in = decodeURI( connection.read() );
						console("client said: " +text_in);
						break;
					};
					$.sleep(100);
				}

				connection.close();
				connection = null;
				console("connection closed.");

				break;
			}
			$.sleep(100);
		}
		socket_in.close();
		console("socket_in closed.");
	}


	return {
		transcript: getStringAfterKey(text_in, '[captured_transcript]:'),
		error: getStringAfterKey(text_in, '[captured_error]:')
	}
}

function getStringAfterKey(text, key) {
	if (text.indexOf(key) != -1)
		return text.substr(text.indexOf(key) + key.length).replace(/^\s+/,'').replace(/\s+$/,''); // (start: number, length: number)
	return '';
}

function console( text ){
	return;
	$.writeln( text );
}